package uloha1;

import java.util.ArrayList;
import java.lang.Math;

  public class Stav{
  
    private int misionari;
    private int kanibalove;
    private int lod;
    private Stav predchoziStav;
    
    public Stav(int m,int k,int l,Stav predchoziStav){
      this.misionari = m;
      this.kanibalove = k;
      this.lod = l;
      this.predchoziStav = predchoziStav;
    }
    
    
    public int infoMisionari(){
      return misionari;
    }
    
    public int infoKanibalove(){
      return kanibalove;
    }
    
    public int infoLod(){
      return lod;
    }
    
    public Stav infoPredchoziStav(){
      return predchoziStav;
    }
    
    
    public boolean jeReseni(){
      return ((misionari == 0) && (kanibalove == 0) && (lod == 0));
    }
    
    
    public boolean jeKonecny(){
      if ((misionari != 0) && (misionari != 3)){
        return ((misionari < kanibalove) || (
        (3 - misionari) < (3 - kanibalove)));
      }
      else {return false;}
    }
    
    
    public boolean jeJiny(Stav s){
      if ((this.misionari != s.misionari) || (this.kanibalove != s.kanibalove)){
        return true;
      }
      else {return false;}
    }
    
    
    public void cestaZpet(){
      Stav mujObjekt = this;
      int i = 0; int m; int k;
      while (mujObjekt.predchoziStav != null) {
        m = Math.abs(mujObjekt.misionari-mujObjekt.infoPredchoziStav().infoMisionari());
        k = Math.abs(mujObjekt.kanibalove-mujObjekt.infoPredchoziStav().infoKanibalove());
        System.out.println("("+mujObjekt.misionari+","+mujObjekt.kanibalove+","+mujObjekt.lod+") - bylo prevezeno "+m+" misionaru a "+k+" kanibalu");
        mujObjekt = mujObjekt.predchoziStav;
        i++;
      }
      System.out.println("(3,3,1)");
      System.out.println("Pocet prejezdu je "+i);
    }
    
    public void pridejDoSeznamu(ArrayList seznam, Stav predchozi){
      if (! this.jeKonecny()){
          if (predchozi == null){
            seznam.add(this);
          }
          else {
            if (predchozi.jeJiny(this)){
            seznam.add(this);
            }
          }
        }
    }
    
    
    public void generujStavy(ArrayList seznam){
      int l; int m; int k; Stav novy; Stav predchozi = this.predchoziStav;
      if (lod == 0){
        l = 1;
        if (misionari < 3){
          m = misionari + 1;
          novy = new Stav(m,kanibalove,l,this);
          novy.pridejDoSeznamu(seznam,predchozi);
        }
      
        if (misionari < 2){
          m = misionari + 2;
          novy = new Stav(m,kanibalove,l,this);
          novy.pridejDoSeznamu(seznam,predchozi);
        }
      
        if (kanibalove < 3){
          k = kanibalove + 1;
          novy = new Stav(misionari,k,l,this);
          novy.pridejDoSeznamu(seznam,predchozi);
        }
      
        if (kanibalove < 2){
          k = kanibalove + 2;
          novy = new Stav(misionari,k,l,this);
          novy.pridejDoSeznamu(seznam,predchozi);
        }
      
        if (misionari < 3 && kanibalove < 3){
          m = misionari + 1;
          k = kanibalove + 1;
          novy = new Stav(m,k,l,this);
          novy.pridejDoSeznamu(seznam,predchozi);
        }
      }
      else {
        l = 0;
        if (misionari > 0){
          m = misionari - 1;
          novy = new Stav(m,kanibalove,l,this);
          novy.pridejDoSeznamu(seznam,predchozi);
        }
      
        if (misionari > 1){
          m = misionari - 2;
          novy = new Stav(m,kanibalove,l,this);
          novy.pridejDoSeznamu(seznam,predchozi);
        }
      
        if (kanibalove > 0){
          k = kanibalove - 1;
          novy = new Stav(misionari,k,l,this);
          novy.pridejDoSeznamu(seznam,predchozi);
        }
      
        if (kanibalove > 1){
          k = kanibalove - 2;
          novy = new Stav(misionari,k,l,this);
          novy.pridejDoSeznamu(seznam,predchozi);
        }
      
        if (misionari > 0 && kanibalove > 0){
          m = misionari - 1;
          k = kanibalove - 1;
          novy = new Stav(m,k,l,this);
          novy.pridejDoSeznamu(seznam,predchozi);
        }
      }
    }


}
